# sms4you

Simple gateway for using SMS with other means of communication.
Currently **email** and **xmpp** are supported. Other protocols might be added.

![sms4you on a Raspberry Pi](./sms4you-raspberry-pi.jpg)

## Idea

Connect a suitable GSM modem or phone containing a SIM card into a computer (e.g. a Raspberry Pi) at a fixed place. Give `sms4you` access to either a simple email address or a small xmpp server. It will use this connection to receive emails or xmpp messages to be sent out as SMS and to send out emails or xmpp messages with received SMS messages.

## Concretely - why?

There can be many reasons, why you want to use `sms4you`. Here are some examples:

* You are living in the internetz, and you just need a gateway to this old thing "SMS", which some people really still seem to use.
* You travel and use local SIM cards, but you still want to be able to receive SMS confirmation codes from banks and services.
* You don't want to carry a (registered) SIM card for [good reasons](https://www.theguardian.com/technology/2016/apr/19/ss7-hack-us-congressman-calls-texts-location-snooping), but still you want to be able to send and receive SMS.

## Requirements

`sms4you` is implemented as a [Python](https://www.python.org/) daemon. At the moment the different gateways for email and xmpp have different depenedencies:

## Installation

* As an [email gateway](./sms4you/README.email.md)
* As an [xmpp gateway](./xmpp-component/README.component.md)

## Copyright and copyleft

Copyright (C) 2019

* Felix Delattre <felix@delattre.de>
* W. Martin Borgert <debacle@debian.org>

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

Also add information on how to contact you by electronic and paper mail.

If your software can interact with users remotely through a computer
network, you should also make sure that it provides a way for users to
get its source.  For example, if your program is a web application, its
interface could display a "Source" link that leads users to an archive
of the code.  There are many ways you could offer source, and different
solutions will be better for different programs; see section 13 for the
specific requirements.

See the [LICENSE.md](./LICENSE.md) for the full license text.
