# sms4you - Email gateway for SMS

Connect a suitable GSM modem or phone for [wammy](https://wammu.eu/phones/), containing a SIM card into a computer (e.g. a Raspberry Pi) at a fixed place. Give `sms4you` access to either a simple email address. It will use this connection to receive emails messages to be sent out as SMS and to send out emails with received SMS messages.

## Requirements

It relies on the [gammu](https://wammu.eu/gammu/) library for communication via SMS, and uses the libaries [imaplib](https://docs.python.org/3/library/imaplib.html) and [smtplib](https://docs.python.org/3/library/smtplib.html) to interact with an email address. For communicating with systemd, you need [sdnotify](https://github.com/bb4242/sdnotify).


## Installation

### Manually

* Install dependencies: `apt install gammu python3-gammu python3-pip python3-sdnotify python3-virtualenv`
* Download the code: `git clone https://github.com/xamanu/sms4you.git`
* Go into the new directory: `cd sms4you`
* Install python dependencies: `pip install -e .`
* Copy and edit the configuration file for sms4you: `cp config/sms4you-example /etc/sms4you/config`
* Copy and edit the configuration file for gammy: `cp config/gammu-example /etc/gammurc`
* Install the systemd service:
  `sudo cp sms4you.service /etc/systemd/system/`
  `sudo systemctl enable sms4you`
  `sudo systemctl start sms4you`
